﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using IDTechSDK;

namespace SREDKey2_Demo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            IDT_Device.setCallback(MessageCallBack);
            IDT_Device.startUSBMonitoring();

        }
        private void SetTitleText(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (InvokeRequired)
            {
                try
                {
                    Invoke((MethodInvoker)delegate
                    {
                        SetTitleText(text);
                    });
                    return;
                }
                catch
                {

                }

            }
                this.Text = text;
            
        }
        private void SetOutputText(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (InvokeRequired)
            {
                try
                {
                    Invoke((MethodInvoker)delegate
                    {
                        SetOutputText(text);
                    });
                    return;
                }
                catch
                {

                }

            }
            if (text == null)
                {
                    tbOutput.Text = "";
                    return;
                }
                try
                {
                    tbOutput.AppendText(text + "\r\n");
                }
                catch (Exception ex)
                {
                }

            

            text = "";
        }
        private void refreshDevices()
        {
            try
            {
                Invoke((MethodInvoker)delegate
                {
                    _refreshDevices();
                });
                return;
            }
            catch
            {

            }
            _refreshDevices();
            

        }

        private void _refreshDevices()
        {

            

            rbSREDKey2.Enabled = Profile.deviceIsInitialized(IDT_DEVICE_Types.IDT_DEVICE_SREDKEY2,
                DEVICE_INTERFACE_Types.DEVICE_INTERFACE_USB);
            rbSREDKey2.Checked = IDT_Device.getDeviceType() == IDT_DEVICE_Types.IDT_DEVICE_SREDKEY2 &&
                                  IDT_Device.getConnectionType() == DEVICE_INTERFACE_Types.DEVICE_INTERFACE_USB &&
                                  IDT_Device.getProtocolType() == DEVICE_PROTOCOL_Types.DEVICE_PROTOCOL_KB && rbSREDKey2.Enabled;

        

  

            buildTreeView();
        }

        delegate void SetTextCallback(string text);

        private void SetOutputTextLog(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (logOutput.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(SetOutputTextLog);
                Invoke(d, new object[] { text });
            }
            else
            {
                if (text == null)
                {
                    logOutput.Text = "";
                    return;
                }
                System.Diagnostics.Debug.WriteLine(text);
                try
                {
                    logOutput.AppendText(text + "\r\n");
                }
                catch (Exception ex)
                {
                    System.Diagnostics.Debug.WriteLine("Exception: " + ex);
                }


            }
        }

        private void SetOutputTextCS(string text)
        {
            // InvokeRequired required compares the thread ID of the
            // calling thread to the thread ID of the creating thread.
            // If these threads are different, it returns true.
            if (InvokeRequired)
            {
                try
                {
                    Invoke((MethodInvoker)delegate
                    {
                        SetOutputTextCS(text);
                    });
                    return;
                }
                catch
                {

                }
            }

     
            if (text == null)
                {
                    tbOutput.Text = "";
                    return;
                }
                try
                {
                    tbOutput.Text = text;
                }
                catch (Exception ex)
                {
                }

            

            text = "";
        }
        public static String GetTimestamp()
        {
            DateTime value = DateTime.Now;
            return value.ToString("HH:mm:ss.fff");
        }

        private void MessageCallBack(IDTechSDK.IDT_DEVICE_Types type, DeviceState state, byte[] data,
      IDTTransactionData cardData, EMV_Callback emvCallback, RETURN_CODE transactionResultCode)
        {
            if (formIsClosing) return;

            if (type == IDT_DEVICE_Types.IDT_DEVICE_SREDKEY2 || type == IDT_DEVICE_Types.IDT_DEVICE_NONE)
            {

            }
            else
            {
                return;
            }

            if (InvokeRequired)
            {
                try
                {
                    Invoke((MethodInvoker)delegate
                    {
                        MessageCallBack(type, state, data, cardData, emvCallback, transactionResultCode);
                    });
                    return;
                }
                catch
                {

                }

            }

 

            IDTechComm comm = Profile.getComm(type, DEVICE_INTERFACE_Types.DEVICE_INTERFACE_USB);
            if (comm == null) comm = Profile.getComm(type, DEVICE_INTERFACE_Types.DEVICE_INTERFACE_SERIAL);
            if (comm == null) comm = Profile.getComm(type, DEVICE_INTERFACE_Types.DEVICE_INTERFACE_BLE);
            if (comm == null) comm = Profile.getComm(type, DEVICE_INTERFACE_Types.DEVICE_INTERFACE_AUDIO_JACK);
            if (comm == null) comm = Profile.getComm(type, DEVICE_INTERFACE_Types.DEVICE_INTERFACE_IP);
            DEVICE_INTERFACE_Types connect = DEVICE_INTERFACE_Types.DEVICE_INTERFACE_UNKNOWN;
            DEVICE_PROTOCOL_Types protocol = DEVICE_PROTOCOL_Types.DEVICE_PROTOCOL_UNKNOWN;
            if (comm != null)
            {
                connect = comm.getDeviceConnection();
                protocol = comm.getDeviceProtocol();
            }

            switch (state)
            {
                case DeviceState.DefaultDeviceTypeChange:
                    // refreshDevices();
                    SetOutputText("\nSDK Default Device =  " + IDTechSDK.Profile.IDT_DEVICE_String(type, connect));
                    SetTitleText("Universal SDK Demo:  " + IDTechSDK.Profile.IDT_DEVICE_String(type, connect));
                    refreshDevices();
                    break;
                case DeviceState.Connected:
                    refreshDevices();
                    SetOutputText(GetTimestamp() + "\nConnected " +
                                  IDTechSDK.Profile.IDT_DEVICE_String(type, connect));
                    SetTitleText("Universal SDK Demo:  " + IDTechSDK.Profile.IDT_DEVICE_String(type, connect));

                    break;
                case DeviceState.Disconnected:
                    refreshDevices();
                    SetOutputText(GetTimestamp() + "\nDisconnected " +
                                  IDTechSDK.Profile.IDT_DEVICE_String(type, connect));
                    break;
                case DeviceState.ConnectionFailed:
                    SetOutputText("\nConnection Failed\n");
                    break;

                case DeviceState.DataReceived:

                    SetOutputTextLog(GetTimestamp() + " IN: " + Common.getHexStringFromBytes(data));
                    break;
                case DeviceState.TransactionData:
                    if (cardData == null)
                    {
                        break;
                    }
                    displayCardData(cardData);
                    break;
                case DeviceState.DataSent:

                    SetOutputTextLog(GetTimestamp() + " OUT: " + Common.getHexStringFromBytes(data));
                    break;
                case DeviceState.RKI:
                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_STARTING_RKI_UPDATE)
                    {
                        SetOutputText(" Staring RKI Process.  Please Wait....\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_NO_SERIAL_NUMBER)
                    {
                        SetOutputText(" RKI Error: Could not retrieve serial number\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_RETRIEVING_CERTIFICATES)
                    {
                        SetOutputText(" RKI Error: Could not retrieve certificates\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_RETRIEVING_KEY_DEVICE_GROUP)
                    {
                        SetOutputText(" RKI Error: Could not retrieve key device group\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_PEDI_FAILED)
                    {
                        SetOutputText( " RKI Error: PEDI Failed\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_INVALID_RSA)
                    {
                        SetOutputText(" RKI Error: Invalid RSA\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_PEDK_FAILED)
                    {
                        SetOutputText(" RKI Error: PEDK Failed\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_PEDK_SET_KEYS_FAILED)
                    {
                        SetOutputText( " RKI Error: PEDK Set Keys Failed\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_PEDV_FAILED)
                    {
                        SetOutputText(" RKI Error: PEDV Failed\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_PEDV_VERIFY_KEYS_FAILED)
                    {
                        SetOutputText( " RKI Error: PEDV Verify Keys Failed\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_COMPLETED_RKI_UPDATE_SUCCESS)
                    {
                        SetOutputText( " RKI Update Finished: Success\n");
                    }

                    if (transactionResultCode ==
                        RETURN_CODE.RETURN_CODE_RKI_COMPLETED_RKI_UPDATE_SUCCESS_MORE_KEYS_AVAILABLE)
                    {
                        SetOutputText( " RKI Update Finished:  More Keys Availble\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_ENDING_SECURE_TASK)
                    {
                        SetOutputText( " RKI Error: Could not end secure task mode\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_UNKNOWN_FAILURE)
                    {
                        SetOutputText( " RKI Error: Unknown Failure\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_FAILED_DEVICE_KEY_REQUEST)
                    {
                        SetOutputText( " Failed on device key request, symmetric RKI.\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_FAILED_SERVER_RECEIVE_KEY)
                    {
                        SetOutputText( "Failed to get keys from the server, symmetric RKI.\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_FAILED_DEVICE_KEY_SET)
                    {
                        SetOutputText( " Failed on device to set key, symmetric RKI.\n");
                    }

                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_ERROR_FAILED_SERVER_VALIDATE_KEY)
                    {
                        SetOutputText( "Failed to validate key with server, symmetric RKI.\n");
                    }
                    if (transactionResultCode == RETURN_CODE.RETURN_CODE_RKI_FAILURE)
                    {
                        SetOutputText( "RKI Failure.\n");
                    }

                    if (data != null && data.Length > 0)
                        SetOutputText( System.Text.Encoding.UTF8.GetString(data) + "\n");
                    break;
                case DeviceState.FirmwareUpdate:
                    switch (transactionResultCode)
                    {

                        case RETURN_CODE.RETURN_CODE_FW_STARTING_UPDATE:
                            SetOutputText( " Starting Firmware Update\n");
                            break;
                        case RETURN_CODE.RETURN_CODE_DO_SUCCESS:
                            SetOutputText( " Firmware Update Successful\n");
                            if (type == IDT_DEVICE_Types.IDT_DEVICE_VP8800) SetOutputText("The device will now reboot and validate the firmware file.  This process may take up to 5 minutes. You may proceed once device is recognized\n");

                            break;
                        case RETURN_CODE.RETURN_CODE_APPLYING_FIRMWARE_UPDATE:
                            SetOutputText( " Applying Firmware Update....\n");
                            break;
                        case RETURN_CODE.RETURN_CODE_ENTERING_BOOTLOADER_MODE:
                            SetOutputText( " Entering Bootloader Mode....\n");
                            break;
                        case RETURN_CODE.RETURN_CODE_BLOCK_TRANSFER_SUCCESS:
                            int start = data[0];
                            int end = data[1];
                            if (data.Length == 4)
                            {
                                start = data[0] * 0x100 + data[1];
                                end = data[2] * 0x100 + data[3];
                            }

                            SetOutputTextCS( " Sent block " + start.ToString() + " of " + end.ToString() + "\n");

                            break;
                        case RETURN_CODE.RETURN_CODE_ERASING_SPI:
                            int start1 = data[0];
                            int end1 = data[1];
                            if (data.Length == 4)
                            {
                                start1 = data[0] * 0x100 + data[1];
                                end1 = data[2] * 0x100 + data[3];
                            }

                            SetOutputTextCS( " Erasing SPI Flash: " + start1.ToString() + "% complete");
                            break;
                        default:
                            SetOutputText(" Firmware Update Error Code: " + "0x" +
                                          String.Format("{0:X}", (ushort)transactionResultCode) + ": " +
                                          IDTechSDK.errorCode.getErrorString(transactionResultCode) + "\r\n");
                            break;
                    }

                    break;
                

                default:
                    break;

            }

        }


        private void btnSDKVersion_Click(object sender, EventArgs e)
        {
            string ver = IDT_Device.SDK_Version();
            tbOutput.AppendText("SDK Version: " + ver + "\r\n");
            System.Diagnostics.Debug.WriteLine("SDK Version: " + ver);

        }
        static RadioButton _lastRadioButton = null;
        private static bool keepInLoop = false;
        private void rbSREDKey2_CheckedChanged(object sender, EventArgs e)
        {
            buildTreeView();
            if (!rbSREDKey2.Checked) return;
            IDT_Device.setDeviceType(IDT_DEVICE_Types.IDT_DEVICE_SREDKEY2, DEVICE_INTERFACE_Types.DEVICE_INTERFACE_USB,
                DEVICE_PROTOCOL_Types.DEVICE_PROTOCOL_KB);
            _lastRadioButton = rbSREDKey2;
        }

        private void buildTreeView()
        {
            //if (lastType == IDT_Device.getDeviceType()) return;
            // lastType = IDT_Device.getDeviceType();
            keepInLoop = false;
            tvCommands.Nodes.Clear();


            if (rbSREDKey2.Checked) buildSREDKey2Tree();



            clearPanels();
        }

        private void clearPanels()
        {
            neoPanel.Visible = false;
            ngaPanel.Visible = false;
            panelSwipeForce.Visible = false;
            panelSwipeMask.Visible = false;
            panelPANDigits.Visible = false;

        }

        private void buildSREDKey2Tree()
        {

            TreeNode expon = new TreeNode("Exp. Mask ON");
            TreeNode expoff = new TreeNode("Exp. Mask OFF");
            TreeNode getexp = new TreeNode("Get Exp. Mask");
            TreeNode panclear = new TreeNode("Set PAN Clear Digits");
            TreeNode gpanclear = new TreeNode("Get PAN Clear Digits");
            TreeNode swforce = new TreeNode("Set Swipe Force Enc.");
            TreeNode gswforce = new TreeNode("Get Swipe Force Enc.");
            TreeNode swipeMask = new TreeNode("Set Swipe Mask");
            TreeNode gswipeMask = new TreeNode("Get Swipe Mask");
            TreeNode dism = new TreeNode("Disable MSR");
            TreeNode disma = new TreeNode("Enable MSR");
            TreeNode fs = new TreeNode("Get MSR Function Status ");

            TreeNode[] marray = new TreeNode[]
            {
                expon, expoff, getexp, panclear, gpanclear, swforce,
                gswforce, swipeMask, gswipeMask, dism,disma, fs
            };
            TreeNode msr = new TreeNode("MSR", marray);
            tvCommands.Nodes.Add(msr);

            TreeNode sn = new TreeNode("Get Serial Number");
            TreeNode mn = new TreeNode("Get Model Number");
            TreeNode[] carray = new TreeNode[] { sn, mn };
            TreeNode config = new TreeNode("Config", carray);
            tvCommands.Nodes.Add(config);

            TreeNode dnode1 = new TreeNode("Reboot Device");
            TreeNode dnode2 = new TreeNode("Send Data Command");
            TreeNode dnode1a = new TreeNode("Send NEO Command");
            TreeNode fw = new TreeNode("Firmware Version");
            TreeNode gks = new TreeNode("Get Status All Key Slots");

            TreeNode ufw = new TreeNode("Update Device Firmware");
            TreeNode ktype = new TreeNode("Get Swipe Encryption");

            TreeNode tid1a = new TreeNode("Get TransArmor ID");
            TreeNode tid2a = new TreeNode("Set TransArmor ID");

            TreeNode adminkey1 = new TreeNode("Enable Admin Key");
            TreeNode adminkey2 = new TreeNode("Disable Admin Key");
            TreeNode lang1 = new TreeNode("Set English Language");
            TreeNode lang2 = new TreeNode("Set Japanese Language");
            TreeNode kb = new TreeNode("USB KB Mode");
            TreeNode hid = new TreeNode("USB HID Mode");
            TreeNode dnode235 = new TreeNode("Execute RKI");
            TreeNode dnode235a = new TreeNode("Set RKI Comm Delay");



            TreeNode[] darray = null;


            darray = new TreeNode[]
            {
                    dnode1,dnode1a, dnode2, fw,  gks,   ufw, ktype, lang1,lang2,kb,hid,tid1a,tid2a,adminkey1,adminkey2,dnode235,dnode235a
            };

            TreeNode device = new TreeNode("Device", darray);
            tvCommands.Nodes.Add(device);

        }

        private static bool formIsClosing = false;
        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            formIsClosing = true;
            Application.Exit();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Profile.closeAllCommConnections();
            IDT_Device.stopUSBMonitoring();
        }
        private string command = "";
        private void button1_Click(object sender, EventArgs e)
        {
            if (command.Equals("Exp. Mask ON")) btnMaskExp_Click(null, null);
            if (command.Equals("Exp. Mask OFF")) btnUnmaskExp_Click(null, null);
            if (command.Equals("Get Exp. Mask")) btnGetExpirationMask_Click(null, null);
            if (command.Equals("Set PAN Clear Digits")) btnSetPAN_Click(null, null);
            if (command.Equals("Get PAN Clear Digits")) btnGetClearPAN_Click(null, null);
            if (command.Equals("Set Swipe Force Enc.")) btnSetSwipeForceEncryption_Click(null, null);
            if (command.Equals("Get Swipe Force Enc.")) btnGetSwipeForceEncryption_Click(null, null);
            if (command.Equals("Set Swipe Mask")) btnSetSwipeMaskOption_Click(null, null);
            if (command.Equals("Get Swipe Mask")) btnGetSwipeMaskOption_Click(null, null);

            if (command.Equals("Disable MSR")) btnDisableMSR_Click(null, null);
            if (command.Equals("Enable MSR")) btnEnableMSR_Click(null, null);
            if (command.Equals("Get MSR Function Status ")) _btnGetMSRFunctionStatus_Click(null, null);
            if (command.Equals("Get Serial Number")) btnGetSerialNumber_Click(null, null);
            if (command.Equals("Get Model Number")) btnModelNumber_Click(null, null);

            if (command.Equals("Reboot Device")) btnReboot_Click(null, null);
            if (command.Equals("Send NEO Command")) btnP2_Click(null, null);
            if (command.Equals("Send Data Command")) btnSendDataCommand_Click(null, null);
            if (command.Equals("Firmware Version")) btnFirmware_Click(null, null);
            if (command.Equals("Get Status All Key Slots")) getStatusAllKeySlots();
            if (command.Equals("Update Device Firmware")) btnUpdateFirmwareIDG_Click(null, null);
            if (command.Equals("Get Swipe Encryption")) btnSwipeEncryption_Click(null, null);
            if (command.Equals("Get TransArmor ID")) getTID();
            if (command.Equals("Set TransArmor ID")) setTID();
            if (command.Equals("Set English Language")) setLanguage(0);
            if (command.Equals("Set Japanese Language")) setLanguage(1);
            if (command.Equals("Enable Admin Key")) EnableAdminKey(true);
            if (command.Equals("Disable Admin Key")) EnableAdminKey(false);
            if (command.Equals("USB KB Mode")) btnUSBKB_Click(null, null);
            if (command.Equals("USB HID Mode")) btnUSBHID_Click(null, null);
            if (command.Equals("Execute RKI")) btnStartRKI_Click(null, null);
            if (command.Equals("Set RKI Comm Delay")) setRKIDelay();

        }



        private void setRKIDelay()
        {
            int setValue = 0;
            int getValue = 0;
            IDT_SREDKey2.SharedController.getRKIDelay(ref setValue, ref getValue);
            string response = Microsoft.VisualBasic.Interaction.InputBox(
                "Please enter the delay (in milliseconds) to insert before executing a SetFeatureReport for command 90-03.",
                "Enter Delay", setValue.ToString(), -1, -1);
            try
            {
                setValue = Convert.ToInt32(response);
            }
            catch
            {
                tbOutput.AppendText("Invalid delay value for SetFeatureReport\r\n");
            }

            response = Microsoft.VisualBasic.Interaction.InputBox(
                "Please enter the delay (in milliseconds) to insert before executing a GetFeatureReport in response to command 90-03.",
                "Enter Delay", getValue.ToString(), -1, -1);
            try
            {
                getValue = Convert.ToInt32(response);
            }
            catch
            {
                tbOutput.AppendText("Invalid delay value for GetFeatureReport\r\n");
            }

            byte[] val = null;
            IDT_Device.SharedController.setRKIDelay(setValue, getValue);

            IDT_Device.SharedController.getRKIDelay(ref setValue, ref getValue);
            tbOutput.AppendText("SetFeatureReport Delay: " + setValue.ToString() + "\r\n");
            tbOutput.AppendText("GetFeatureReport Delay: " + getValue.ToString() + "\r\n");

        }

        private void btnStartRKI_Click(object sender, EventArgs e)
        {
            tbOutput.AppendText("\r\nStaring RKI Process.  Please Wait...\r\n");
            System.Diagnostics.Debug.WriteLine("Staring RKI Process.  Please Wait... \r\n");

            RETURN_CODE rt = IDT_SREDKey2.SharedController.device_startRKI();
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("\r\nRKI Successful\r\n");
                System.Diagnostics.Debug.WriteLine("RKI Successful \r\n");

            }
            else
            {
                tbOutput.AppendText("RKI Fail Error Code: " + "0x" + String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("RKI Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }
        }

        private void btnUSBHID_Click(object sender, EventArgs e)
        {
            RETURN_CODE rt = IDT_Device.SharedController.msr_switchUSBInterfaceMode(false);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("MSR Enter into USB HID Mode successfully\r\n");
                System.Diagnostics.Debug.WriteLine("MSR Enter into USB HID Mode successfully");
            }
            else
            {
                tbOutput.AppendText("MSR Enter into USB HID Mode failed Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("MSR Enter into USB HID Mode failed Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }

        }


        private void btnUSBKB_Click(object sender, EventArgs e)
        {
            RETURN_CODE rt = IDT_SREDKey2.SharedController.msr_switchUSBInterfaceMode(true);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("MSR Enter into USB KB Mode successfully\r\n");
                System.Diagnostics.Debug.WriteLine("MSR Enter into USB KB Mode successfully");
            }
            else
            {
                tbOutput.AppendText("MSR Enter into USB KB Mode failed Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("MSR Enter into USB KB Mode failed Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }

        }

        private void EnableAdminKey(bool enable)
        {
            byte type = 0;

            RETURN_CODE rt = IDT_SREDKey2.SharedController.device_enableAdminKey(enable);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                if (enable) tbOutput.AppendText("Admin Key Enabled\r\n");
                else tbOutput.AppendText("Admin Key Disabled\r\n");
            }
            else
            {
                tbOutput.AppendText("Admin Key enable/disable Fail Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Get Key Type For ICC DUKPT Key Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }
        }


        private void setLanguage(int val)
        {



            RETURN_CODE rt = IDT_SREDKey2.SharedController.device_setLanguage(val);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("SetLang uage executed successfully.\r\n");

            }
            else
            {
                tbOutput.AppendText("Set Language failed Error Code: " + "0x" + String.Format("{0:X}", (ushort)rt) +
                                    ": " + IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
            }


        }
        private void setTID()
        {
            string tid = Microsoft.VisualBasic.Interaction.InputBox("Please enter TransArmor ID to set.",
                "Set TransArmor ID", "00000000", -1, -1);

            if (tid.Length != 8)
            {
                tbOutput.AppendText("TID must be 8 digits.  \r\n");

                return;
            }

            RETURN_CODE rt = IDT_SREDKey2.SharedController.device_setTransArmorID(tid);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("Set TransArmor ID Successful.\r\n");
                System.Diagnostics.Debug.WriteLine("Set TransArmor ID Successful");
            }
            else
            {
                tbOutput.AppendText("Set TransArmor ID failed Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Set TransArmor ID failed Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }


        }

        private void getTID()
        {

            string tid = null;
            RETURN_CODE rt = IDT_SREDKey2.SharedController.device_getTransArmorID(ref tid);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("Get TransArmor ID Successful. ID: " + tid + "\r\n");
                System.Diagnostics.Debug.WriteLine("Get TransArmor ID Successful");
            }
            else
            {
                tbOutput.AppendText("Get TransArmor ID failed Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Get TransArmor ID failed Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }


        }


        private void btnSwipeEncryption_Click(object sender, EventArgs e)
        {
            byte format = 0;

            RETURN_CODE rt = IDT_SREDKey2.SharedController.msr_getSwipeEncryption(ref format);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                if (format == 0x31)
                {
                    tbOutput.AppendText("Swipe Encryption for MSR: TDES" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Swipe Encryption for MSR: TDES");
                }
                else if (format == 0x32)
                {
                    tbOutput.AppendText("Swipe Encryption for MSR: AES" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Swipe Encryption for MSR: AES");
                }
                else
                {
                    tbOutput.AppendText("Swipe Encryption for MSR: None" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Swipe Encryption for MSR: None");
                }
            }
            else
            {
                tbOutput.AppendText("Swipe Encryption for MSR  Fail Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + "\n\r");
                System.Diagnostics.Debug.WriteLine("Swipe Encryption for MSR  Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));

            }
        }




        private void btnUpdateFirmwareIDG_Click(object sender, EventArgs e)
        {
            OpenFileDialog diag = new OpenFileDialog();

                openFW.Filter = "FW Files|*.fm";


            if (openFW.ShowDialog() == DialogResult.OK)
            {

                byte[] file = File.ReadAllBytes(openFW.FileName);
                RETURN_CODE rt = IDT_SREDKey2.SharedController.device_updateDeviceFirmware(file);
                if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
                {

                    tbOutput.AppendText("Firmware Update Started...\r\n");
                }
                else
                {
                    tbOutput.AppendText("Firmware Update Failed Error Code: " + "0x" +
                                        String.Format("{0:X}", (ushort)rt) + ": " +
                                        IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Firmware Update Failed Error Code: " + "0x" +
                                                       String.Format("{0:X}", (ushort)rt));
                }
            }

        }

        private void getStatusAllKeySlots()
        {
            byte[] slots = null;
            RETURN_CODE rt = IDT_SREDKey2.SharedController.config_getStatusKeySlots(ref slots);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {

                tbOutput.AppendText("Slot Info " + Common.getHexStringFromBytes(slots) + "\r\n");
            }
            else
            {
                tbOutput.AppendText("Get Key Slot Status Failed Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
            }
        }
        private void btnFirmware_Click(object sender, EventArgs e)
        {



            string firmwareVersion = "";
            RETURN_CODE rt = IDT_SREDKey2.SharedController.device_getFirmwareVersion(ref firmwareVersion);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("Firmware Ver: " + firmwareVersion + "\r\n");
                System.Diagnostics.Debug.WriteLine("Firmware Ver: " + firmwareVersion);
            }
            else
            {
                tbOutput.AppendText("Get Firmware Fail Error Code: " + "0x" + String.Format("{0:X}", (ushort)rt) +
                                    ": " + IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Get Firmware Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }


        }



        private void btnSendDataCommand_Click(object sender, EventArgs e)
        {
            if (tbCommand.Text.Length == 0) return;
            String command = tbCommand.Text;
            command = command.Replace(" ", "");




            byte[] response = new byte[0];
            IDTechComm.calcNextITP = rbITP.Checked;
            IDTechComm.calcNextNGA = rbNGA.Checked;
            RETURN_CODE rt = IDT_SREDKey2.SharedController.device_sendDataCommand_ext(tbCommand.Text, rbNGA.Checked || rbITP.Checked,
                ref response, Convert.ToInt32(tbTimout.Text), cbNoResponse.Checked);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {

                tbOutput.AppendText("Send Command Response HEX: " + Common.getHexStringFromBytes(response) + "\r\n");

                for (int x = 0; x < response.Length; x++)
                {
                    if (response[x] < 0x20 || response[x] > 0x7d) response[x] = 0x3f;

                }

                tbOutput.AppendText("Send Command Response ASCII: " + System.Text.Encoding.UTF8.GetString(response) +
                                    "\r\n");
                System.Diagnostics.Debug.WriteLine("Send Command Response: " + Common.getHexStringFromBytes(response));
            }
            else
            {
                tbOutput.AppendText("Send Command Fail Error Code: " + "0x" + String.Format("{0:X}", (ushort)rt) +
                                    ": " + IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Send Command Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }

        }


        private void btnP2_Click(object sender, EventArgs e)
        {
            byte[] response = null;
            RETURN_CODE rt = 0;
            if (tbp2cmd.Text.Length != 2 || tbp2sub.Text.Length != 2)
            {
                tbOutput.AppendText("Invalid Parameters\r\n");
                return;
            }

            if (v2.Checked)
            {
                rt = IDT_SREDKey2.SharedController.device_sendVivoCommandP2_ext(Common.getByteArray(tbp2cmd.Text)[0],
                    Common.getByteArray(tbp2sub.Text)[0], Common.getByteArray(tbp2data.Text), ref response,
                    Convert.ToInt32(tbTimeoutNeo.Text), cbNoResponseNeo.Checked);
            }
            else if (v3.Checked)
            {
                rt = IDT_SREDKey2.SharedController.device_sendVivoCommandP3_ext(Common.getByteArray(tbp2cmd.Text)[0],
                    Common.getByteArray(tbp2sub.Text)[0], Common.getByteArray(tbp2data.Text), ref response,
                    Convert.ToInt32(tbTimeoutNeo.Text), cbNoResponseNeo.Checked);
            }
            else if (v4.Checked)
            {
                rt = IDT_SREDKey2.SharedController.device_sendVivoCommandP4_ext(Common.getByteArray(tbp2cmd.Text)[0],
                    Common.getByteArray(tbp2sub.Text)[0], Common.getByteArray(tbp2data.Text), ref response,
                    Convert.ToInt32(tbTimeoutNeo.Text), cbNoResponseNeo.Checked);
            }

            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                if (response != null)
                    tbOutput.AppendText("Send P2 Command successful:" + Common.getHexStringFromBytes(response) +
                                        "\r\n");
                else tbOutput.AppendText("Send P2 Command successful\r\n");
                System.Diagnostics.Debug.WriteLine("Send P2 Command");
            }
            else
            {
                tbOutput.AppendText("Send P2 Command Error Code: " + "0x" + String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Send P2 Command Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }
        }

        private void btnReboot_Click(object sender, EventArgs e)
        {
            RETURN_CODE rt = IDT_SREDKey2.SharedController.device_rebootDevice();
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("Device Reboot successfully\r\n");
                System.Diagnostics.Debug.WriteLine("Device Reboot successfully");
            }
            else
            {
                tbOutput.AppendText("Device Reboot failed Error Code: " + "0x" + String.Format("{0:X}", (ushort)rt) +
                                    ": " + IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Device Reboot failed Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }
        }

        private void btnModelNumber_Click(object sender, EventArgs e)
        {
            string modelNumber = "";

            RETURN_CODE rt = IDT_SREDKey2.SharedController.config_getModelNumber(ref modelNumber);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("Model Number: " + modelNumber + "\r\n");
                System.Diagnostics.Debug.WriteLine("Model Number: " + modelNumber);
            }
            else
            {
                tbOutput.AppendText("Get Model Number Fail Error Code: " + "0x" + String.Format("{0:X}", (ushort)rt) +
                                    ": " + IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Get Model Number Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }
        }

        private void btnGetSerialNumber_Click(object sender, EventArgs e)
        {
            string sNumber = "";

            RETURN_CODE rt = IDT_SREDKey2.SharedController.config_getSerialNumber(ref sNumber);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("Serial Number: " + sNumber + "\r\n");
                System.Diagnostics.Debug.WriteLine("Serial Number: " + sNumber);
            }
            else
            {
                tbOutput.AppendText("Get Serial Number Fail Error Code: " + "0x" + String.Format("{0:X}", (ushort)rt) +
                                    ": " + IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Get Serial Number Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }
        }

        private void _btnGetMSRFunctionStatus_Click(object sender, EventArgs e)
        {
            bool enable = false;
            bool isBufferMode = false;
            bool withNotification = false;
            RETURN_CODE rt =
                IDT_SREDKey2.SharedController.msr_getFunctionStatus(ref enable, ref isBufferMode, ref withNotification);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                if (enable)
                    tbOutput.AppendText("MSR Reader " + (enable == true ? "Enabled " : "Disabled ") +
                                        (isBufferMode == true ? "Buffer Mode " : "Auto Mode ") +
                                        (withNotification == true ? " with Notification." : " without Notification.") +
                                        "\r\n");
                else
                    tbOutput.AppendText("MSR Reader Disabled.");
                System.Diagnostics.Debug.WriteLine("MSR Reader " + (enable == true ? "Enabled " : "Disabled ") +
                                                   (withNotification == true
                                                       ? " with Notification."
                                                       : " without Notification.") + "\r\n");
            }
            else
            {
                tbOutput.AppendText("Get MSR Function Status Failed Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Get MSR Function Status Failed Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }


        }

        private void btnSetSwipeForceEncryption_Click(object sender, EventArgs e)
        {
            RETURN_CODE rt =
                IDT_SREDKey2.SharedController.msr_setSwipeForcedEncryptionOption(cbT1.Checked, cbT2.Checked, cbT3.Checked,
                    cbT30.Checked);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {

                tbOutput.AppendText("Set Swipe Force Encryption  Successful" + "\r\n");
                System.Diagnostics.Debug.WriteLine("Set Swipe Force Encryption  Successful");
            }
            else
            {
                tbOutput.AppendText("Set Swipe Force Encryption Unsuccessful: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");


            }
        }

        private void btnGetSwipeForceEncryption_Click(object sender, EventArgs e)
        {
            byte format = 0;

            RETURN_CODE rt = IDT_SREDKey2.SharedController.msr_getSwipeForcedEncryptionOption(ref format);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                if ((format & 0x01) == 0x01)
                {
                    tbOutput.AppendText("Track 1 Swipe Force Encryption: ON" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 1 Swipe Force Encryption: ON");
                }
                else
                {
                    tbOutput.AppendText("Track 1 Swipe Force Encryption: OFF" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 1 Swipe Force Encryption: OFF");
                }

                if ((format & 0x02) == 0x02)
                {
                    tbOutput.AppendText("Track 2 Swipe Force Encryption: ON" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 2 Swipe Force Encryption: ON");
                }
                else
                {
                    tbOutput.AppendText("Track 2 Swipe Force Encryption: OFF" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 2 Swipe Force Encryption: OFF");
                }

                if ((format & 0x04) == 0x04)
                {
                    tbOutput.AppendText("Track 3 Swipe Force Encryption: ON" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 3 Swipe Force Encryption: ON");
                }
                else
                {
                    tbOutput.AppendText("Track 3 Swipe Force Encryption: OFF" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 3 Swipe Force Encryption: OFF");
                }

                if ((format & 0x08) == 0x08)
                {
                    tbOutput.AppendText("Track 3 Option 0 Swipe Force Encryption: ON" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 3 Option 0 Swipe Force Encryption: ON");
                }
                else
                {
                    tbOutput.AppendText("Track 3 Option 0 Swipe Force Encryption: OFF" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 3 Option 0 Swipe Force Encryption: OFF");
                }

            }
            else
            {
                tbOutput.AppendText("Get Swipe Force Encryption  Fail Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + "\n\r");
                System.Diagnostics.Debug.WriteLine("Get Swipe Force Encryption  Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));

            }
        }

        private void btnSetSwipeMaskOption_Click(object sender, EventArgs e)
        {
            RETURN_CODE rt =
                IDT_SREDKey2.SharedController.msr_setSwipeMaskOption(cbM1.Checked, cbM2.Checked, cbM3.Checked);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {

                tbOutput.AppendText("Set Swipe Mask Option  Successful" + "\r\n");
                System.Diagnostics.Debug.WriteLine("Set Swipe Mask Option  Successful");
            }
            else
            {
                tbOutput.AppendText("Set Swipe Mask Option Unsuccessful: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                


            }
        }

        private void btnGetSwipeMaskOption_Click(object sender, EventArgs e)
        {
            byte format = 0;

            RETURN_CODE rt = IDT_SREDKey2.SharedController.msr_getSwipeMaskOption(ref format);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                if ((format & 0x01) == 0x01)
                {
                    tbOutput.AppendText("Track 1 Mask Option: ON" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 1 Mask Option: ON");
                }
                else
                {
                    tbOutput.AppendText("Track 1 Mask Option: OFF" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 1 Mask Option: OFF");
                }

                if ((format & 0x02) == 0x02)
                {
                    tbOutput.AppendText("Track 2 Mask Option: ON" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 2 Mask Option: ON");
                }
                else
                {
                    tbOutput.AppendText("Track 2 Mask Option: OFF" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 2 Mask Option: OFF");
                }

                if ((format & 0x04) == 0x04)
                {
                    tbOutput.AppendText("Track 3 Mask Option: ON" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 3 Mask Option: ON");
                }
                else
                {
                    tbOutput.AppendText("Track 3 Mask Option: OFF" + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Track 3 Mask Option: OFF");
                }


            }
            else
            {
                tbOutput.AppendText("Get Mask Option  Fail Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Get Mask Option  Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));

            }
        }

        private void btnSetPAN_Click(object sender, EventArgs e)
        {
            RETURN_CODE rt = IDT_SREDKey2.SharedController.msr_setClearPANID((byte)numPAN.Value);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {

                tbOutput.AppendText("Set Clear Pan Digits Successful" + "\r\n");
                System.Diagnostics.Debug.WriteLine("Set Clear Pan Digits Successful");
            }
            else
            {
                tbOutput.AppendText("Set Clear Pan Digits Unsuccessful" + "0x" + String.Format("{0:X}", (ushort)rt) +
                                    ": " + IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Set Clear Pan Digits Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }
        }

        private void btnGetClearPAN_Click(object sender, EventArgs e)
        {
            byte response = 0x00;
            RETURN_CODE rt = IDT_SREDKey2.SharedController.msr_getClearPANID(ref response);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {

                tbOutput.AppendText("Get Clear PAN Digits Response: " + (int)(response) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Get Clear PAN Digits Response: " + (int)(response));
            }
            else
            {
                tbOutput.AppendText("Get Clear PAN Digits Fail Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Get Clear PAN Digits Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }
        }

        private void btnGetExpirationMask_Click(object sender, EventArgs e)
        {
            byte response = 0x00;
            RETURN_CODE rt = IDT_SREDKey2.SharedController.msr_getExpirationMask(ref response);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {

                tbOutput.AppendText("Expiration Masking: " + ((response == 0x30) ? "Masked" : "Unmasked") + "\r\n");
                System.Diagnostics.Debug.WriteLine(
                    "Expiration Masking: " + ((response == 0x30) ? "Masked" : "Unmasked"));
            }
            else
            {
                tbOutput.AppendText("Expiration Masking Fail Error Code: " + "0x" +
                                    String.Format("{0:X}", (ushort)rt) + ": " +
                                    IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
            }
        }


        private void btnMaskExp_Click(object sender, EventArgs e)
        {
            RETURN_CODE rt = IDT_SREDKey2.SharedController.msr_setExpirationMask(true);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {

                tbOutput.AppendText("Set Expiration Mask Successful" + "\r\n");
                System.Diagnostics.Debug.WriteLine("Set Expiration Mask Successful");
            }
            else
            {
                tbOutput.AppendText("Set Expiration Mask Unsuccessful" + "0x" + String.Format("{0:X}", (ushort)rt) +
                                    ": " + IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Set Expiration Mask Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }
        }

        private void btnUnmaskExp_Click(object sender, EventArgs e)
        {
            RETURN_CODE rt = IDT_SREDKey2.SharedController.msr_setExpirationMask(false);
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {

                tbOutput.AppendText("Set Expiration Unmask Successful" + "\r\n");
                System.Diagnostics.Debug.WriteLine("Set Expiration Unmask Successful");
            }
            else
            {
                tbOutput.AppendText("Set Expiration Unmask Unsuccessful" + "0x" + String.Format("{0:X}", (ushort)rt) +
                                    ": " + IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("Set Expiration Unmask Fail Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }
        }

        private void btnDisableMSR_Click(object sender, EventArgs e)
        {
            RETURN_CODE rt = IDT_SREDKey2.SharedController.msr_disable();
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("MSR Disable successfully\r\n");
                System.Diagnostics.Debug.WriteLine("MSR Disable successfully");
            }
            else
            {
                tbOutput.AppendText("MSR Disable failed Error Code: " + "0x" + String.Format("{0:X}", (ushort)rt) +
                                    ": " + IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("MSR Disable failed Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }


        }

        private void btnEnableMSR_Click(object sender, EventArgs e)
        {
            RETURN_CODE rt = IDT_SREDKey2.SharedController.msr_enable();
            if (rt == RETURN_CODE.RETURN_CODE_DO_SUCCESS)
            {
                tbOutput.AppendText("MSR Enabled successfully\r\n");
                System.Diagnostics.Debug.WriteLine("MSR Disable successfully");
            }
            else
            {
                tbOutput.AppendText("MSR Enable failed Error Code: " + "0x" + String.Format("{0:X}", (ushort)rt) +
                                    ": " + IDTechSDK.errorCode.getErrorString(rt) + "\r\n");
                System.Diagnostics.Debug.WriteLine("MSR Disable failed Error Code: " + "0x" +
                                                   String.Format("{0:X}", (ushort)rt));
            }


        }

        private void tvCommands_AfterSelect(object sender, TreeViewEventArgs e)
        {
            
            command = e.Node.Text;
            clearPanels();



            if (command.Equals("Send NEO Command")) neoPanel.Visible = true;
            if (command.Equals("Send Data Command")) ngaPanel.Visible = true;
            if (command.Equals("Set Swipe Force Enc.")) panelSwipeForce.Visible = true;
            if (command.Equals("Set Swipe Mask")) panelSwipeMask.Visible = true;
            if (command.Equals("Set PAN Clear Digits")) panelPANDigits.Visible = true;


        }

        private void Form1_Load(object sender, EventArgs e)
        {

        }

        private void btnClearLogs_Click(object sender, EventArgs e)
        {
            logOutput.Text = "";
            tbOutput.Text = "";
        }

        private void displayCardData(IDTTransactionData cardData)
        {
            string text = "";
            if (cardData != null && cardData.Base64 != null && cardData.Base64.Length > 0)
                text += "Base64 Raw Data: " + cardData.Base64 + "\r\n\r\n";
            if (cardData != null && cardData.fastEMV != null && cardData.fastEMV.Length > 0)
                text += "Fast EMV Data: " + cardData.fastEMV + "\r\n\r\n";
    

            if (cardData.Event == EVENT_TRANSACTION_DATA_Types.EVENT_TRANSACTION_DATA_CARD_DATA)
            {
                if (cardData.msr_rawData != null)
                {
                    SetOutputText("Data received: (Length [" + cardData.msr_rawData.Length.ToString() + "])\n" +
                                  string.Concat(cardData.msr_rawData.ToArray().Select(b => b.ToString("X2"))
                                      .ToArray()) + "\r\n");
                    System.Diagnostics.Debug.WriteLine("Data received: (Length [" +
                                                       cardData.msr_rawData.Length.ToString() + "])\n" +
                                                       string.Concat(cardData.msr_rawData.ToArray()
                                                           .Select(b => b.ToString("X2")).ToArray()));
                }

            }

            if (cardData.captured_KSN != null)
            {
                //encrypted captured data
                if (cardData.captured_InitialVector != null)
                    text += "Man. Captured Initial Vector: " +
                            Common.getHexStringFromBytes(cardData.captured_InitialVector) + "\r\n";
                if (cardData.captured_KSN != null)
                    text += "Man. Captured KSN: " + Common.getHexStringFromBytes(cardData.captured_KSN) + "\r\n";
                if (cardData.captured_PAN != null)
                    text += "Man. Captured Encrypted PAN: " + Common.getHexStringFromBytes(cardData.captured_PAN) +
                            "\r\n";
                if (cardData.captured_Expiry != null)
                    text += "Man. Captured Encrypted Expiry: " +
                            Common.getHexStringFromBytes(cardData.captured_Expiry) + "\r\n";
                if (cardData.captured_CSC != null)
                    text += "Man. Captured Encrypted CSC: " + Common.getHexStringFromBytes(cardData.captured_CSC) +
                            "\r\n";
                if (cardData.captured_firstPANDigits != null && cardData.captured_firstPANDigits.Length > 0)
                    text += "PAN First Digits: " + cardData.captured_firstPANDigits + "\r\n";
                if (cardData.captured_lastPANDigits != null && cardData.captured_firstPANDigits.Length > 0)
                    text += "PAN Last Digits: " + cardData.captured_lastPANDigits + "\r\n";
                if (cardData.captured_MACValue != null)
                    text += "Man. Captured MAC: " + Common.getHexStringFromBytes(cardData.captured_MACValue) + "\r\n";
                if (cardData.captured_MACKSN != null)
                    text += "Man. Captured MAC KSN: " + Common.getHexStringFromBytes(cardData.captured_MACKSN) + "\r\n";




            }
            else if (cardData.captured_PAN != null)
            {
                //unecnrypted captured data
                if (cardData.captured_PAN != null)
                    text += "Man. Captured  PAN: " + System.Text.Encoding.UTF8.GetString(cardData.captured_PAN) +
                            "\r\n";
                if (cardData.captured_Expiry != null)
                    text += "Man. Captured  Expiry: " + System.Text.Encoding.UTF8.GetString(cardData.captured_Expiry) +
                            "\r\n";
                if (cardData.captured_CSC != null)
                    text += "Man. Captured  CSC: " + System.Text.Encoding.UTF8.GetString(cardData.captured_CSC) +
                            "\r\n";
            }



            if (cardData.device_RSN != null && cardData.device_RSN.Length > 0)
                text += "Serial Number: " + cardData.device_RSN + "\r\n";

            if (cardData.msr_track1Length > 0)
                text += "Track 1: " + cardData.msr_track1 + "\r\n";

            if (cardData.msr_encTrack1 != null)
                text += "Track 1 Encrypted: " + Common.getHexStringFromBytes(cardData.msr_encTrack1) + "\r\n";



            if (cardData.msr_hashTrack1 != null)
                text += "Track 1 Hash: " + Common.getHexStringFromBytes(cardData.msr_hashTrack1) + "\r\n";




            if (cardData.msr_track2Length > 0)
                text += "Track 2: " + cardData.msr_track2 + "\r\n";


            if (cardData.msr_encTrack2 != null)
                text += "Track 2 Encrypted: " + Common.getHexStringFromBytes(cardData.msr_encTrack2) + "\r\n";


            if (cardData.msr_hashTrack2 != null)
                text += "Track 2 Hash: " + Common.getHexStringFromBytes(cardData.msr_hashTrack2) + "\r\n";




            if (cardData.msr_track3Length > 0)
                text += "Track 3: " + cardData.msr_track3 + "\r\n";


            if (cardData.msr_encTrack3 != null)
                text += "Track 3 Encrypted: " + Common.getHexStringFromBytes(cardData.msr_encTrack3) + "\r\n";


            if (cardData.msr_hashTrack3 != null)
                text += "Track 3 Hash: " + Common.getHexStringFromBytes(cardData.msr_hashTrack3) + "\r\n";

            if (cardData.msr_KSN != null)
                text += "KSN: " + Common.getHexStringFromBytes(cardData.msr_KSN) + "\r\n";


  


            if (cardData.mac != null)
                text += "MAC: " + Common.getHexStringFromBytes(cardData.mac) + "\r\n";

            if (cardData.macKSN != null)
                text += "MAC KSN: " + Common.getHexStringFromBytes(cardData.macKSN) + "\r\n";

            if (cardData.msr_sessionID != null)
                text += "Session ID: " + Common.getHexStringFromBytes(cardData.msr_sessionID) + "\r\n";

         

     

            SetOutputText(text);

            text = "";
  

        }



    }
}
